unit PAI1216u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    CardName: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    ExitBtn: TBitBtn;
    GroupBox1: TGroupBox;
    Memo1: TMemo;
    Edit0: TEdit;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit7: TEdit;
    Edit6: TEdit;
    Edit5: TEdit;
    Edit4: TEdit;
    Edit12: TEdit;
    Edit11: TEdit;
    Edit10: TEdit;
    Edit9: TEdit;
    Edit8: TEdit;
    Edit15: TEdit;
    Edit14: TEdit;
    Edit13: TEdit;
    ChannelsCombo: TComboBox;
    GetDataBtn: TBitBtn;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Edit19: TEdit;
    Edit23: TEdit;
    Edit22: TEdit;
    Edit21: TEdit;
    Edit20: TEdit;
    Edit24: TEdit;
    Edit25: TEdit;
    Edit26: TEdit;
    Edit27: TEdit;
    Edit31: TEdit;
    Edit30: TEdit;
    Edit29: TEdit;
    Edit28: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Timer1: TTimer;
    procedure ExitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GetDataBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetCardInfoWDM;
    procedure NoFifo(CardNum: Integer);
    procedure Fifo(CardNum: Integer);
    procedure SetChannel(CardNum: Integer; channel: BYTE; diff_se: Boolean);
    procedure SetFifoChannels(CardNum: Integer);
    procedure StartConversion(CardNum: Integer);
    function WaitForEOC(CardNum: Integer): WORD;
    function RetrieveADConversion(CardNum: Integer): SmallInt;
    procedure EnableFifoCounter(CardNum: Integer);
    procedure CheckFifo(CardNum: Integer);
    procedure DisableCounters(CardNum: Integer);
    procedure ResetFifos(CardNum: Integer);
  end;

var
  Form1: TForm1;
  NumCards, CardNum : Integer;
  RunFlag, TimedOut: Boolean;
  HasFifo: Boolean;
  VoltsDisplay: array [0..15] of TEdit;
  CountsDisplay: array [0..15] of TEdit;
  Testing: Boolean;



implementation

uses AIOWDM;

{$R *.DFM}

procedure CtrMode(CardNum: Integer; cntr, mode: byte);
begin
  RelOutPortB(CardNUm, 8 + 3, (cntr shl 6) or $30 or (mode shl 1));
end;
//---------------------------------------------------------------------------
procedure CtrLoad(CardNum: Integer; c, val: word);
begin
  RelOutPortB(CardNUm, 8 + c, val and $00FF);
  RelOutPortB(CardNUm, 8 + c, (val shr 8) and $00FF);
end;
//---------------------------------------------------------------------------
procedure TForm1.ExitBtnClick(Sender: TObject);
begin
    Close;
end;

procedure TForm1.GetCardInfoWDM;
var
    found: Boolean;

    DeviceID, Base: LongWord;
    NameSize: LongWord;
    Name: String;
    Success: LongWord;

begin

    found := false;
    RunFlag:=True;

    if (InPortB($61) = $AA55) then begin
        Application.MessageBox(' AIOWDM.SYS not detected.\n Please copy AIOWDM.SYS into [Windows]/system32/drivers and re-run this sample.\n Ensure that a board is installed properly.', 'Warning', IDOK);
    end;

    NumCards := GetNumCards();
    CardNum := 0; // one and only card

    if NumCards = 0 then begin
        Memo1.Text := 'No cards found. The cards may not be installed, or they may be installed using a driver other than AIOWDM.sys.';
    end;

      NameSize := 256;
      SetString(Name, nil, NameSize);
      Success := QueryCardInfo(CardNum, @DeviceID, @Base, @NameSize, PChar(Name));
      SetLength(Name, NameSize - 1);
         case (DeviceID) of
            $ECA9: begin
               CardName.Caption:='PCI-A12-16 Analog I/O Card with Digital';
               found := true;
               HasFifo := false;  // The non -A cards do not have a FIFO
            end;
            $ECAA: begin
               CardName.Caption:='PCI-A12-16A Analog I/O Card with Digital';
               found := true;
               HasFifo := true    // the -A cards have FIFOs
            end;

            $ACA8: begin
               CardName.Caption:='PCI-AI12-16 Analog I/O Card with Digital';
               found := true;
               HasFifo := false;
            end;
            $ACA9: begin
               CardName.Caption:='PCI-AI12-16A Analog I/O Card with Digital';
               found := true;
               HasFifo := true
            end;
         end;{case}

    if not found then
    begin
        CardName.Caption:='No Card Found.';
        Memo1.Lines.Clear;
        Memo1.Lines.Append('No PCI Card Found.');
        Memo1.Lines.Append('The sample program might not have been updated for your specific device ID.');

        if (NumCards > 0) then
        begin
            Memo1.Lines.Append('NOTE: A PCI card was found, but it is not for this sample.');
        end;


        RunFlag:=False;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

    GetCardInfoWDM;

    ChannelsCombo.ItemIndex := 0;
    VoltsDisplay[0] := Edit0;
    VoltsDisplay[1] := Edit1;
    VoltsDisplay[2] := Edit2;
    VoltsDisplay[3] := Edit3;
    VoltsDisplay[4] := Edit4;
    VoltsDisplay[5] := Edit5;
    VoltsDisplay[6] := Edit6;
    VoltsDisplay[7] := Edit7;
    VoltsDisplay[8] := Edit8;
    VoltsDisplay[9] := Edit9;
    VoltsDisplay[10] := Edit10;
    VoltsDisplay[11] := Edit11;
    VoltsDisplay[12] := Edit12;
    VoltsDisplay[13] := Edit13;
    VoltsDisplay[14] := Edit14;
    VoltsDisplay[15] := Edit15;
    CountsDisplay[0] := Edit16;
    CountsDisplay[1] := Edit17;
    CountsDisplay[2] := Edit18;
    CountsDisplay[3] := Edit19;
    CountsDisplay[4] := Edit20;
    CountsDisplay[5] := Edit21;
    CountsDisplay[6] := Edit22;
    CountsDisplay[7] := Edit23;
    CountsDisplay[8] := Edit24;
    CountsDisplay[9] := Edit25;
    CountsDisplay[10] := Edit26;
    CountsDisplay[11] := Edit27;
    CountsDisplay[12] := Edit28;
    CountsDisplay[13] := Edit29;
    CountsDisplay[14] := Edit30;
    CountsDisplay[15] := Edit31;

end;

procedure TForm1.GetDataBtnClick(Sender: TObject);
begin
    if not RunFlag then
        Memo1.Lines.Append('Cannot run without card!')
    else if Testing then
    begin
        Testing := false;
        Timer1.Enabled := false;
        GetDataBtn.Caption := 'Get Data';
    end else
    begin
        Testing := true;
        Timer1.Enabled := true;
        GetDataBtn.Caption := 'Stop Data';
    end;
end;
//---------------------------------------------------------------------------
procedure TForm1.Fifo(CardNum: Integer);
var
    chan, numchan: byte;
    Value: word;
    counts: smallint;
    volts: double;
begin
    if ChannelsCombo.ItemIndex = 0 then
        numchan := 8
    else
        numchan := 16;
    ResetFifos(CardNum);
    SetFifoChannels(CardNum);
    CtrMode(CardNum, 1, 2);
    CtrLoad(CardNum, 1, $2);
    CtrMode(CardNum, 2, 2);
    CtrLoad(CardNum, 2, $FF);
    EnableFifoCounter(CardNum);//conversions started once counters are enabled
    CheckFifo(CardNum); //check fifo bit to see if it's half full
    DisableCounters(CardNum);//stop conversions
    while((RelInPortB(CardNum, 4) and $02) = $02) do//bit goes low when fifo is empty
    begin
        Value := RelInPort(CardNUm,0);
        counts := Value and $FFF;
        if (counts > $7FF) then
            counts := counts or $F000;
        chan := Value shr 12;
        volts := 20.0 * (counts / 4095.0);//convert to volts: counts*max volt span/max counts
        if (chan >= numchan) then
        begin
            VoltsDisplay[chan].Text := '';
            CountsDisplay[chan].Text := '';
        end else
        begin
            VoltsDisplay[chan].Text := FloatToStrF(volts, ffFixed, 0, 3);
            CountsDisplay[chan].Text := IntToStr(counts);
        end;
    end;
end;
//---------------------------------------------------------------------------
procedure TForm1.NoFifo(CardNum: Integer);
var
    chan, numchan: BYTE;
    counts: smallint;
    volts: real;
    Ticks: DWORD;
begin
    DisableCounters(CardNum);
    if ChannelsCombo.ItemIndex = 0 then
        numchan := 8
    else
        numchan := 16;
    for chan := 0 to 15 do
    begin
        if chan >= numchan then
        begin
            VoltsDisplay[chan].Text := '';
            CountsDisplay[chan].Text := '';
        end else
        begin
            SetChannel(CardNum, chan, numchan=8); // write channel, range, SE or diff
            Ticks := GetTickCount;
            while Ticks + 2 > GetTickCount do; // allow for settle time
            StartConversion(CardNum);  // start conversion
            if (WaitForEOC(CardNum) = 0) then  //WAITFOREOC returns zero if it times out
            begin
                Memo1.Lines.Append('Channel ' + IntToStr(chan) + ' A/D Timed Out');
                VoltsDisplay[chan].Text := '';
                CountsDisplay[chan].Text := '';
            end else
            begin
                counts := RetrieveADConversion(CardNum);
                volts := 20.0 * (counts / 4095.0); //convert to volts: counts*max volt span/max counts
                VoltsDisplay[chan].Text := FloatToStr(volts);
                CountsDisplay[chan].Text := IntToStr(counts);
            end;
        end;
    end;
end;
//---------------------------------------------------------------------------
procedure TForm1.SetChannel(CardNum: Integer; channel: BYTE; diff_se: Boolean);
var
    Value: Byte;
begin
    Value := (channel shl 4); //channel selected in upper nibble at base+2
                                          // and single-ended, range +/-10V
    RelOutPortB(CardNum, 2, Value or $08); // set Differential
end;
//---------------------------------------------------------------------------
procedure TForm1.SetFifoChannels(CardNum: Integer);
begin
    RelOutPort(CardNum, 2, $0000);
    RelOutPort(CardNum, 2, $1010);
    RelOutPort(CardNum, 2, $2020);
    RelOutPort(CardNum, 2, $3030);
    RelOutPort(CardNum, 2, $4040);
    RelOutPort(CardNum, 2, $5050);
    RelOutPort(CardNum, 2, $6060);
    RelOutPort(CardNum, 2, $7070);
    RelOutPort(CardNum, 2, $8080);
    RelOutPort(CardNum, 2, $9090);
    RelOutPort(CardNum, 2, $A0A0);
    RelOutPort(CardNum, 2, $B0B0);
    RelOutPort(CardNum, 2, $C0C0);
    RelOutPort(CardNum, 2, $D0D0);
    RelOutPort(CardNum, 2, $E0E0);
    RelOutPort(CardNum, 2, $F0F0);
    RelInPortB(CardNum, 2);
end;
//---------------------------------------------------------------------------
procedure TForm1.EnableFifoCounter(CardNum: Integer);
begin
    RelOutPortB(CardNum, 4, 1); // enable conversion on counter
end;

procedure TForm1.CheckFifo(CardNum: Integer);
begin
  while((RelInPortB(CardNum, 4) and $04) = $04) do;//bit goes low when fifo half full
end;
//---------------------------------------------------------------------------
procedure TForm1.DisableCounters(CardNum: Integer);
begin
    RelOutPort(CardNum, 4, 0);
end;
//---------------------------------------------------------------------------
procedure TForm1.ResetFifos(CardNum: Integer);
var
    i: Integer;
begin
    RelOutPort(CardNum, 4, $48);//0x40 resets channel fifo, 0x08 resets data fifo
    for i := 0 to 1023 do
        RelInPortB(CardNum, 0);
    RelInPortB(CardNum, 6);
end;
//---------------------------------------------------------------------------
procedure TForm1.StartConversion(CardNum: Integer);
begin
    RelOutPortB(CardNum, 0 , 0); //write anything to base+0 to start conversion
end;

function TForm1.WaitForEOC(CardNum: Integer): WORD;
var
    timeout: WORD;
begin
    timeout := $FFFF;
    while((RelInPortB(CardNum, 4) and $80) = 0) and (timeout > 0) do
        Dec(timeout);
    Result := timeout; //0==error
end;
//---------------------------------------------------------------------------
function TForm1.RetrieveADConversion(CardNum: Integer): SmallInt;
var
    data: SmallInt;
begin
    data := (RelInPort(CardNum, 0) and $0FFF); //mask upper nibble
    if (data and $800) > 0 then
        data := data or $F000; // effectively sign-extend
    Result := data;
end;
//---------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
    if HasFifo then
        Fifo(CardNum)
    else
        NoFifo(CardNum)
end;

end.
